"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var hash = require('object-hash');
var resolveAuth = function (auth, payload) {
    return new Promise(function (resolve) {
        auth(payload, function (status) {
            resolve(!!status);
        });
    });
};
exports.isDefined = function (data) {
    return typeof data !== 'undefined';
};
exports.hashContent = function (input) {
    return hash(input);
};
exports.resolveAuths = function (auths, payload, trigger) { return __awaiter(_this, void 0, void 0, function () {
    var _i, auths_1, auth, status_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _i = 0, auths_1 = auths;
                _a.label = 1;
            case 1:
                if (!(_i < auths_1.length)) return [3 /*break*/, 4];
                auth = auths_1[_i];
                return [4 /*yield*/, resolveAuth(auth, payload)];
            case 2:
                status_1 = _a.sent();
                if (!status_1) {
                    return [2 /*return*/, trigger(false)];
                }
                _a.label = 3;
            case 3:
                _i++;
                return [3 /*break*/, 1];
            case 4:
                trigger(true);
                return [2 /*return*/];
        }
    });
}); };
exports.generateTestQueryParamValues = function (params) {
    var result = {};
    lodash_1.keys(params).forEach(function (key) {
        switch (params[key].toLowerCase()) {
            case 'string': {
                result[key] = 'test';
                break;
            }
            case 'number': {
                result[key] = 123;
                break;
            }
            case 'boolean': {
                result[key] = true;
                break;
            }
            case 'undefined': {
                result[key] = undefined;
                break;
            }
            case 'null': {
                result[key] = null;
                break;
            }
            case 'date': {
                result[key] = new Date();
                break;
            }
            // array is not supported. It should be flatted in the template
            // case 'array': {
            //     result[key] = [];
            //     break;
            // }
            // object is not supported. It should be flatted in the template
            // case 'object': {}
            default: {
                throw Error("Unsupported query param value type: '" + params[key] + "' is an invalid/unsupported type");
            }
        }
    });
    return result;
};
exports.generateQueryFromTemplate = function (templateStr, variableMap) {
    // use custom delimiter {{ }} as used in the the labels
    lodash_1.templateSettings.interpolate = /{{([\s\S]+?)}}/g;
    // interpolate
    var compile = lodash_1.template(templateStr);
    return JSON.parse(compile(variableMap));
};
